# patch QEDprocesses
# see issue https://github.com/QEDjl-project/QEDprocesses.jl/issues/77
@inline function QEDprocesses.number_particles(
    proc_def::QEDbase.AbstractProcessDefinition, dir::DIR, ::PT
) where {DIR<:QEDbase.ParticleDirection,PT<:QEDbase.AbstractParticleType}
    return count(x -> x isa PT, particles(proc_def, dir))
end


"""
    number_particles(proc_def::AbstractProcessDefinition, dir::ParticleDirection, species::AbstractParticleType)

Return the number of particles of the given direction and species in the given process definition.
"""
@inline function QEDbase.number_particles(
    proc_def::AbstractProcessDefinition, dir::DIR, species::PT
) where {DIR<:ParticleDirection,PT<:AbstractParticleType}
    return count(x -> x isa PT, particles(proc_def, dir))
end

"""
    number_particles(proc_def::AbstractProcessDefinition, particle::AbstractParticleStateful)

Return the number of particles of the given particle's direction and species in the given process definition.
"""
@inline function QEDbase.number_particles(
    proc_def::AbstractProcessDefinition, ps::AbstractParticleStateful
)
    return number_particles(proc_def, particle_direction(ps), particle_species(ps))
end
